package
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
	/*
	*	Le principe des courbes de lissajou est basé sur la composition de 2 mouvements sinusoidales
	*	Un mouvement d'aller-retour horizontal
	*	Un mouvement d'aller-retour vertical
	*	La difference entre les vitesses d'implémentation de l'angle vont créer des courbes très différentes
	*	La difference des rayons d'angle également.
	*/
	public class Lissajou extends Sprite
	{
		private var background:Bitmap;
		private var data:BitmapData;
		private var horizontal_support:Sprite;
		private var horizontal_angle:Number = 0;
		private var vertical_support:Sprite;
		private var vertical_angle:Number = 0;
		private var canevas:Sprite;
		private var vitesseH:Number;
		private var vitesseV:Number;
		//private var vitesseF:Number;
		
		public function Lissajou()
		{
			data = new BitmapData(600,600,false,0x000000);
			background = new Bitmap(data);
			
			addChild(background);
			canevas = new Sprite();	
			addChild(canevas);
			
			/*
			 * PARAMETRAGE DES VITESSES 
			 * EN MODIFIANT CES PARAMETRES VOUS AUREZ DES COURBES VARIANTES
			 */
			vitesseH = 5;
			vitesseV = 1;
			//vitesseF = 1;
			
			
			buildHorizontalMovement();
		}
		
		private function buildHorizontalMovement():void
		{
			horizontal_support = new Sprite();
			horizontal_support.x= 0.1;
			horizontal_support.y= 300;
			
			canevas.addChild(horizontal_support);
			
			horizontal_support.addEventListener(Event.ENTER_FRAME,horizontal_enter_handler);
			
			buildVerticalMovement(horizontal_support);
		}
		
		private function horizontal_enter_handler(e:Event):void
		{
			horizontal_angle+=vitesseH;
			//e.currentTarget.x = Math.sin(horizontal_angle*Math.PI/180)*200 + 290;
			e.currentTarget.x = Math.cos(horizontal_angle*Math.PI/550)*50 + 250;
		}
		
		private function buildVerticalMovement(clip:Sprite):void
		{
			vertical_support = new Sprite();
			vertical_support.graphics.beginFill(0x000FF,2);
			vertical_support.graphics.drawRect(8,8,8,3);
			vertical_support.graphics.endFill();
			
			clip.addChild(vertical_support);
			
			vertical_support.addEventListener(Event.ENTER_FRAME,vertical_enter_handler);
		}
		
		private function vertical_enter_handler(e:Event):void
		{
			vertical_angle+=vitesseV;
			e.currentTarget.y = Math.sin(vertical_angle*Math.PI/500)*200;
			data.draw(canevas);
		}
	}
}